module Aemet
  class City
    attr_reader :aemet_id

    def initialize(aemet_id)
      @aemet_id = aemet_id
    end

    def weather
      @weather ||= get_weather
    end

    private

    def weather_response
      @weather_response ||= HTTParty.get(xml_url)
    end

    def get_weather
      @weather = Hashie::Mash.new(weather_response).root
    end

    def xml_url
      "#{BASE_URL}/xml/municipios/localidad_#{aemet_id}.xml"
    end

  end
end
