# encoding: utf-8

require 'cgi' unless defined?(CGI)
require 'httparty'
require 'nokogiri'
require 'hashie'

module Aemet
  BASE_URL = "http://www.aemet.es"

  class Crawler

    attr_reader :search
    attr_accessor :aemet_id, :city

    def initialize(search)
      @search = CGI.escape(search.parameterize(" "))
      search_city
    end

    private

    def search_city
      city_pattern = ".resultados_busqueda li a:contains('Predicción por Municipios')"

      search_results = Nokogiri::HTML(HTTParty.get(search_url)).search(city_pattern)

      first_result = search_results.first

      if first_result
        first_result[:href] =~ /-id(.*)\Z/

        self.aemet_id = $1
        self.city = City.new(aemet_id)
      else
        raise "Not found"
      end
    end

    def search_url
      "#{BASE_URL}/es/buscador?modo=and&orden=n&tipo=sta&str=#{search}"
    end
  end
end
